Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.om
Interface SequenceIterator<T extends Item>

All Known Subinterfaces:
  AxisIterator<T>, GroundedIterator<T>, GroupIterator, LookaheadIterator<T>, RegexIterator, ReversibleIterator<T>, UnfailingIterator<T>

All Known Implementing Classes:
  AdjacentTextNodeMergingIterator, ArrayIterator, AtomizingIterator, AxisAtomizingIterator, AxisIteratorImpl, AxisIteratorOverSequence, BlockIterator, CardinalityCheckingIterator, CompiledBlockIterator, CompiledFilterIterator, ContextMappingIterator, DifferenceEnumeration, DistinctValues.DistinctIterator, DocumentOrderIterator, EmptyAxisIterator, EmptyIterator, ErrorIterator, EveryItemMappingIterator, FilterIterator, FilterIterator.NonNumeric, GroupAdjacentIterator, GroupByIterator, GroupEndingIterator, GroupMatchingIterator, GroupStartingIterator, HomogeneityCheckerIterator, IndexOf.IndexIterator, Insert.InsertIterator, IntersectionEnumeration, ItemMappingIterator, IteratorIterator, JRegexIterator, JTokenIterator, ListIterator, LookaheadIteratorImpl, ManualIterator, MappingIterator, MemoClosure.ProgressiveIterator, MergeEnumeration, MergeGroupingIterator, MultithreadedContextMappingIterator, Navigator.AncestorEnumeration, Navigator.AxisFilter, Navigator.BaseEnumeration, Navigator.DescendantEnumeration, Navigator.EmptyTextFilter, Navigator.FollowingEnumeration, Navigator.PrecedingEnumeration, NodeWrappingAxisIterator, OneToOneMappingIterator, PrependIterator, RangeIterator, Remove.RemoveIterator, ReturnClauseIterator, ReverseArrayIterator, ReverseRangeIterator, SequenceComposer, SequenceExchanger.Consumer, SingleNodeIterator, SingletonIterator, SortedGroupIterator, SortedIterator, StringTokenIterator, StringValue.CharacterIterator, SubsequenceIterator, TailIterator, UnionEnumeration, UnparsedTextIterator, UntypedAtomizingIterator, ValueTailIterator, VirtualCopy.VirtualCopier, VirtualUntypedCopy.VirtualUntypedCopier, WrappingIterator

    public interface SequenceIterator<T extends Item>

A SequenceIterator is used to iterate over any XPath 2 sequence (of values or nodes). To get the next item in a sequence, call next(); if this returns null, you've reached the end of the sequence.

A SequenceIterator keeps track of the current Item and the current position. The objects returned by the SequenceIterator will always be either nodes (class NodeInfo) or singleton values (class AtomicValue): these are represented collectively by the interface Item.

This interface forms part of the public Saxon API. The JavaDoc "since" flag is used from release 8.4 onwards to indicate methods that are considered to be a stable part of the API. Methods without a "since" flag should not be regarded as a stable part of the API.

Note that the stability of this interface applies to classes that use the interface, not to classes that implement it. The interface may be extended in future to add new methods.

Since:
  8.4
Author:
  Michael H. Kay

Field Summary
`static int` | `GROUNDED` Property value: the iterator is "grounded".
`static int` | `LAST_POSITION_FINDER` Property value: the iterator knows the number of items that it will deliver.
`static int` | `LOOKAHEAD` Property value: the iterator knows whether there are more items still to come.

Method Summary
`void` | `close()` Close the iterator.
`T` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator<T>` | `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`T` | `next()` Get the next item in the sequence.
`int` | `position()` Get the current position.

Field Detail

### GROUNDED

    static final int GROUNDED

  Property value: the iterator is "grounded". This means that (a) the iterator must be an instance of `GroundedIterator`, and (b) the implementation of the materialize() method must be efficient (in particular, it should not involve the creation of new objects)

  See Also:
    Constant Field Values

### LAST_POSITION_FINDER

    static final int LAST_POSITION_FINDER

  Property value: the iterator knows the number of items that it will deliver. This means that (a) the iterator must be an instance of `LastPositionFinder`, and (b) the implementation of the getLastPosition() method must be efficient (in particular, it should take constant time, rather than time proportional to the length of the sequence)

  See Also:
    Constant Field Values

### LOOKAHEAD

    static final int LOOKAHEAD

  Property value: the iterator knows whether there are more items still to come. This means that (a) the iterator must be an instance of `LookaheadIterator`, and (b) the implementation of the hasNext() method must be efficient (more efficient than the client doing it)

  See Also:
    Constant Field Values

Method Detail

### next

    T next()
                        throws XPathException

  Get the next item in the sequence. This method changes the state of the iterator, in particular it affects the result of subsequent calls of position() and current().

  Returns:
    the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
  Throws:
    `XPathException` - if an error occurs retrieving the next item
  Since:
    8.4

### current

    T current()

  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.

  Returns:
    the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.
  Since:
    8.4

### position

    int position()

  Get the current position. This will usually be zero before the first call on next(), otherwise it will be the number of times that next() has been called. Once next() has returned null, the preferred action is for subsequent calls on position() to return -1, but not all existing implementations follow this practice. (In particular, the EmptyIterator is stateless, and always returns 0 as the value of position(), whether or not next() has been called.)

  This method does not change the state of the iterator.

  Returns:
    the current position, the position of the item returned by the most recent call of next(). This is 1 after next() has been successfully called once, 2 after it has been called twice, and so on. If next() has never been called, the method returns zero. If the end of the sequence has been reached, the value returned will always be <= 0; the preferred value is -1.
  Since:
    8.4

### close

    void close()

  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Since:
    9.1

### getAnother

    SequenceIterator<T> getAnother()
                                                throws XPathException

  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  This method allows access to all the items in the sequence without disturbing the current position of the iterator. Internally, its main use is in evaluating the last() function.

  This method does not change the state of the iterator.

  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item
  Throws:
    `XPathException` - if any error occurs
  Since:
    8.4

### getProperties

    int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Returns:
    the properties of this iterator. This will be some combination of properties such as `GROUNDED`, `LAST_POSITION_FINDER`, and `LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.
  Since:
    8.6

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.